{-# LANGUAGE PatternSynonyms, ScopedTypeVariables, ViewPatterns #-}


-- | Copyright  : Will Thompson and Iñaki García Etxebarria
-- License    : LGPL-2.1
-- Maintainer : Iñaki García Etxebarria

#if (MIN_VERSION_haskell_gi_overloading(1,0,0) && !defined(__HADDOCK_VERSION__))
#define ENABLE_OVERLOADING
#endif

module GI.GdkPixbuf.Constants
    ( 
    pattern PIXBUF_VERSION                  ,
    pattern PIXBUF_MINOR                    ,
    pattern PIXBUF_MICRO                    ,
    pattern PIXBUF_MAJOR                    ,

    ) where

import Data.GI.Base.ShortPrelude
import qualified Data.GI.Base.ShortPrelude as SP
import qualified Data.GI.Base.Overloading as O
import qualified Prelude as P

import qualified Data.GI.Base.Attributes as GI.Attributes
import qualified Data.GI.Base.BasicTypes as B.Types
import qualified Data.GI.Base.ManagedPtr as B.ManagedPtr
import qualified Data.GI.Base.GArray as B.GArray
import qualified Data.GI.Base.GClosure as B.GClosure
import qualified Data.GI.Base.GError as B.GError
import qualified Data.GI.Base.GHashTable as B.GHT
import qualified Data.GI.Base.GVariant as B.GVariant
import qualified Data.GI.Base.GValue as B.GValue
import qualified Data.GI.Base.GParamSpec as B.GParamSpec
import qualified Data.GI.Base.CallStack as B.CallStack
import qualified Data.GI.Base.Properties as B.Properties
import qualified Data.GI.Base.Signals as B.Signals
import qualified Control.Monad.IO.Class as MIO
import qualified Data.Coerce as Coerce
import qualified Data.Text as T
import qualified Data.Kind as DK
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map
import qualified Foreign.Ptr as FP
import qualified GHC.OverloadedLabels as OL
import qualified GHC.Records as R
import qualified Data.Word as DW
import qualified Data.Int as DI
import qualified System.Posix.Types as SPT
import qualified Foreign.C.Types as FCT

-- Workaround for https://gitlab.haskell.org/ghc/ghc/-/issues/23392
#if MIN_VERSION_base(4,18,0)

#else

#endif

-- | Contains the full version of GdkPixbuf as a string.
-- 
-- This is the version being compiled against; contrast with
-- @gdk_pixbuf_version@.
pattern PIXBUF_VERSION = "2.42.12" :: T.Text

-- | Minor version of gdk-pixbuf library, that is the \"8\" in
-- \"0.8.2\" for example.
pattern PIXBUF_MINOR = 42 :: Int32

-- | Micro version of gdk-pixbuf library, that is the \"2\" in
-- \"0.8.2\" for example.
pattern PIXBUF_MICRO = 12 :: Int32

-- | Major version of gdk-pixbuf library, that is the \"0\" in
-- \"0.8.2\" for example.
pattern PIXBUF_MAJOR = 2 :: Int32


